import { R as RemoteUploaderService } from './el-result-BYk3F9qI.js';
import { i as isSafeInteger, a as ContentScriptToBackgroundEvent, f as firstValueFrom, M as MessagePortSubject, b as MAGIC, c as CommonEvent } from './message-g8wSSm3N.js';
import { n as init_1 } from './index-hZERwo9M.js';
import { g as getSessionStorage, r as recordStop, w as waitForClientConnect } from './fetch-BWmuaPuD.js';
import { b as browser } from './browser-polyfill-BkiQUeYD.js';
import { r as removeTabAvailable, s as setTabAvailable } from './tabs-D9QrqSEf.js';
import { s as setupWebExtensionServer } from './server-CUiLH4gJ.js';
import { b as bridge } from './content-script-BrV6Jqw5.js';
import './vue-i18n.runtime-BBVXiHAN.js';
import './interval-BgVj3k04.js';
import './switchMap-BlpT1cA0.js';
import './chunk-E2HJRHOS-DUhzpE8A.js';
import './chunk-QIZ4XBKF-DPG0WA40.js';

async function setupIntermediary(bridge) {
    if (!window.parent || window.parent === window) {
        return;
    }
    const { sendMessage } = bridge;
    const tab = await browser.tabs.getCurrent();
    const browserTabId = tab?.id;
    if (!isSafeInteger(browserTabId)) {
        throw new Error();
    }
    const tabId = String(browserTabId);
    const { frameId } = await sendMessage(ContentScriptToBackgroundEvent.GetFrameId, null, 'background');
    const createId = init_1({
        fingerprint: String(frameId)
    });
    const session = getSessionStorage();
    const { onClientConnect, ctx } = setupWebExtensionServer(tabId, {
        session,
        async startRecord (args) {
            const { windowId } = tab;
            if (!windowId) {
                return;
            }
            return await sendMessage(CommonEvent.StartRecord, {
                ...args,
                tabId: browserTabId,
                windowId
            });
        }
    });
    const { recorderState$, container } = ctx;
    RemoteUploaderService.register(container, bridge);
    const isRootFrame = window.top === window.parent;
    if (isRootFrame && recorderState$.getValue().snapshotTabId === String(tabId)) {
        recordStop(recorderState$, false);
    }
    firstValueFrom(waitForClientConnect()).then((event)=>{
        const port = event.ports[0];
        const message$ = new MessagePortSubject(port, String(tab.id));
        onClientConnect(createId(), message$);
        if (isRootFrame) {
            window.onbeforeunload = ()=>{
                removeTabAvailable(browserTabId, String(frameId));
                if (recorderState$.getValue().snapshotTabId === String(tabId)) {
                    recordStop(recorderState$, false);
                }
            };
            return setTabAvailable(browserTabId, String(frameId));
        }
        return undefined;
    });
    window.parent.postMessage(MAGIC, '*');
}

setupIntermediary(bridge);
